﻿using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using Infragistics.Windows.DockManager;
using Infragistics.Windows.DockManager.Events;

namespace PaneToolWindowExpansionSample
{
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDockManager_ToolWindowLoaded(object sender, PaneToolWindowEventArgs e)
        {
            var control = FindVisualChildren<MyUserControl>(e.Window.Content as DependencyObject).FirstOrDefault();

            if (control != null)
            {
                e.Window.Width = control.ActualWidth;
                e.Window.Height = control.ActualHeight;
            }
        }

        private static IEnumerable<T> FindVisualChildren<T>(DependencyObject depObj) where T : DependencyObject
        {
            if (depObj != null)
            {
                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(depObj); i++)
                {
                    DependencyObject child = VisualTreeHelper.GetChild(depObj, i);
                    if (child is T)
                    {
                        yield return (T)child;
                    }

                    foreach (T childOfChild in FindVisualChildren<T>(child))
                    {
                        yield return childOfChild;
                    }
                }
            }
        }

        private void OnWindowLoaded(object sender, RoutedEventArgs e)
        {
            var pane = new ContentPane {Content = new MyUserControl(), Header = "New Tab"};

            TabGroupPane.Items.Add(pane);
        }
    }
}
